/*
----------------------- Coverage Calculator Macro -----------------------
Version: 1.0
Updated: 16 Aug 2017

This macro automates the wand tool and ROI saving functions to semi-automate
detection of ROIs, i.e. by simply clicking within the ROI.
-------------------------------------------------------------------------
*/

print("\\Clear");
print("----- ROI Detector tool initiated -----");

//Dialog.create("Sampling options");
//Dialog.addNumber("Number of markings (e.g. spots, stripes) in your pattern:", 1)
//Dialog.addNumber("Number of nested layers in your markings (e.g. a solid circles = 1,\na black centre with a gold rim = 2):", 1)
//Dialog.show();
//numMarks = Dialog.getNumber();
//numNests = Dialog.getNumber();

tol = 50;
xCoord = 0;
yCoord = 0;
done = 0;
choices = newArray("Refresh","Discard", "Save");
bug = "<html>"
   +"Common Bug: <b>Clicking doesn't work.</b><br>"
   +"This is an ImageJ issue that happens because you are clicking<br>"
   +"inside an existing ROI.<br> <br>"
   +"Solutions:<br>"
   +"1) Hold [Shift] and move the cursor then try again<br>"
   +"OR<br>"
   +"1) Choose any other tool (e.g. rectangle or oval)<br>"
   +"2) Click and drag the existing ROI aside<br>"
   +"3) Select the hand tool and try again<br> <br>" 
   +"If both don't work, close and restart this tool; your saved ROIs<br>
   +"should still be in the ROI Manager."
numROIs=roiManager("count");
if(roiManager("count")>0)
	print(numROIs+" existing ROI(s) detected in ROI Manager.");
shift=1;
left=16;
insideROI = 32; // requires 1.42i or later
newName="";

//setTool("rectangle");
setTool("hand");
title1 = "Instructions";
title2 = "["+title1+"]";
run("Text Window...", "name="+title2+" width=86 height=9");
print(title2, "1) Click on a marking to auto-detect an ROI (try clicking on different parts)");
print(title2, "\n2) Adjust the Tolerance value");
print(title2, "\n3) If auto-detect doesn't work (e.g. faded markings), switch to another tool (e.g. circle,");
print(title2, "\n polygon) to manually draw an ROI; switch back to the Hand tool to restart auto-detect");
print(title2, "\n4) Repeat for all ROIs");
print(title2, "\n5) CLOSE THIS WINDOW when all ROIs have been added");
print(title2, "\n \nNOTE: If CLICKING SEEMS STUCK, hold <shift> and move the cursor then try again");
//print(title2, "Instructions:\n1) Click on a marking to create an ROI (try clicking on different parts)\n2) Adjust the Tolerance value\n3) If auto detection doesn't work (e.g. faded markings), switch to another \ntool (e.g. circle, polygon) to manually draw the ROI\n4) Press <t> to add the ROI to the ROI Manager\n5) Repeat for all ROIs\n6) CLOSE THIS WINDOW when all ROIs have been added\n \nCommon Bug: If clicking has no effect, it might be due to an ImageJ bug, \nbecause you are clicking inside an existing ROI. \nSolution: Choose another tool and click and drag the ROI aside; then \nselect the hand tool and try again. If this doesn't work, close this window \nand restart this tool; your saved ROIs should still be in the ROI Manager.");
setLocation(200,100);

while(isOpen(title1)==1) {
	getCursorLoc(x, y, z, flags);
	if(IJ.getToolName()=="hand" && (flags&shift)!=0){
//	if(IJ.getToolName()=="hand" && (flags&leftButton&insideROI)>0){
		run("Select None");
	}
	if(IJ.getToolName()=="hand" && flags==16){
//	if(IJ.getToolName()=="hand" && (flags&left)!=0){
		done = 0;
		xCoord = x;
		yCoord = y;
//		doWand(xCoord,yCoord,tol,"4-connected");
//		call("Versatile_Wand_Tool.doWand", xCoord, yCoord, tol, colorSensitivity, gradientTolerance, "options");
		while(done==0){
			doWand(xCoord,yCoord,tol,"4-connected");
			Dialog.create("Tolerance adjustment...");
			Dialog.setInsets(0,0,0);
			Dialog.addSlider("1) Adjust tolerance",0,255,tol);
			Dialog.setInsets(0,100,0);
			Dialog.addMessage("Less Area                  More Area");
//			Dialog.setInsets(0,150,0);
//			Dialog.addCheckbox("Done", false);
			Dialog.setInsets(0,0,0);
//			Dialog.addMessage("2) Select: 'Refresh' to preview the adjustment; 'Save'\n to finish; or 'Discard' to discard the current ROI");
//			Dialog.addRadioButtonGroup("", choices, 1, 3, "Refresh");
			Dialog.addRadioButtonGroup("2) Select: 'Refresh' to preview the adjustment; 'Save'\n to finish; or 'Discard' to discard the current ROI", choices, 1, 3, "Refresh");
			Dialog.setInsets(10,0,0);
			Dialog.addMessage("3) [Optional] Name this ROI:");
			Dialog.setInsets(0,0,0);
			Dialog.addString("",newName,10);
			Dialog.setInsets(10,0,0);
			Dialog.addMessage("4) Click 'OK'");
			Dialog.setInsets(0,25,0);
			Dialog.addMessage("IMPORTANT: DO NOT CLICK 'CANCEL'!! \nTo discard this ROI, check 'Discard' and click 'OK'");
			Dialog.addHelp(bug);
			Dialog.setLocation(225,125);
			Dialog.show();
			tol = Dialog.getNumber();
//			done = Dialog.getCheckbox();
			choice = Dialog.getRadioButton();
			newName = Dialog.getString();
			if(choice=="Save"){
				done = 1;
				roiManager("add");
				if(newName!=""){
					roiManager("select", roiManager("count")-1);
					roiManager("rename",newName);
// at this point, ImageJ detects flags as 48 (within ROI and left click is active)
				}
				newName="";
			}
			if(choice=="Discard"){
				done = 1;
				newName="";
// cannot run("Select None") here because on click, ImageJ will still detect left click, but no longer inside ROI (i.e. flags = 16) and so re-enter the while loop
			}
		}
	}
	if(roiManager("count")>numROIs){
		print("ROI added.");
		numROIs=roiManager("count");
	}
	if(roiManager("count")<numROIs){
		print("ROI removed.");
		numROIs=roiManager("count");
	}
}

print(numROIs+" ROI(s) captured.");
print("To rename your ROIs, use the ROI Renamer tool.");
print("To save your ROIs, highlight all of them in the ROI Manager,\nthen click 'more' and 'save...'.");
//print("To take measurements of your ROIs, select the appropriate \nPAT-GEOM macro.");
print("-----End of Macro-----");
exit();







/* Old code using number of ROIs
while (roiManager("count")<numSpots*numRings) {
	getCursorLoc(x, y, z, flags);
//	xCoord = x;
//	yCoord = y;
	if(flags==16){
		doWand(x,y,tol,"8-connected");
//		call("Versatile_Wand_Tool.doWand", xCoord, yCoord, tol, colorSensitivity, gradientTolerance, "options");
	}
}
*/

/*
run("Duplicate...", "title=Working_Image.jpg");
Dialog.create("Sampling options");
Dialog.addNumber("Number of concentric rings in your circles (solid circles = 1):", 1)
Dialog.show();
numRings = Dialog.getNumber();
ringNum = Array.getSequence(numRings+1);
colLowTol = 0.25;
colUppTol = 0.15;
sizeLowTol = 0.8;
sizeUppTol = 0.25;

for(i=1;i<=numRings;i++){
//	choices = newArray("Marking lighter than surroundings","Marking darker than surroundings");
//	Dialog.create("Concentric Ring "+ringNum[i]+"(Starting from Outside)");
//	Dialog.addChoice("Marking type:", choices, "Marking lighter than surroundings");
//	Dialog.addNumber("Number of samples needed:",10);
//	Dialog.show();
//	choice = Dialog.getChoice;
	//numSamples = Dialog.getNumber();
	numSamples = 100;
	setTool("oval");
	run("Select None");
	waitForUser("Colour Sampling", "Draw an ROI over concentric ring "+ringNum[i]+" and click OK when you're done. \n \nNote: be as accurate as possible. Hold the 'alt' key and draw more \ninner ROIs to remove any unwanted portions not of the same colour.");
	//getStatistics(area, mean, min, max, std, histogram);
	getSelectionBounds(x,y,width,height);
	minX = x;
	minY = y;
	maxX = minX+width;
	maxY = minY+height;
	xCoords = newArray(numSamples);
	yCoords = newArray(numSamples);
//	for(j=0; j<numSamples; j++){
//		xCoords[j] = ((maxX-minX)*random)+minX;
//		yCoords[j] = ((maxY-minY)*random)+minY;
//	}
	index=0;
	while(index<numSamples){
		tempx = ((maxX-minX)*random)+minX;
		tempy = ((maxY-minY)*random)+minY;
		test = Roi.contains(tempx,tempy);
		if(test==1){
			xCoords[index] = tempx;
			yCoords[index] = tempy;	
			index++;
		}else if(test==0){
			continue;
		}
	}

	setTool("oval");
	run("Select None");
	waitForUser("Size Sampling", "Draw a simple oval over the outside of the largest ring.");
	getSelectionBounds(x,y,width,height);
	biggestArea = 3.142*width*height*(1+sizeUppTol);
	run("Select None");
	waitForUser("Size Sampling", "Draw a simple oval over the outside of the smallest ring.");
	getSelectionBounds(x,y,width,height);
	smallestArea = 3.142*width*height*(1-sizeLowTol);


	// Color Thresholder 1.51j
//	if(choice=="Marking lighter than surroundings")
//		setAutoThreshold("Default dark");
//	else if(choice=="Marking darker than surroundings")
//		setAutoThreshold("Default");
	minA=newArray(3);
	maxA=newArray(3);
	filterA=newArray(3);
	img=getTitle();
	run("RGB Stack");
	run("Convert Stack to Images");
	selectWindow("Red");
	rename("0");
	pixelValues = newArray(numSamples);
	for(j=0; j<numSamples; j++){
		pixelValues[j] = getPixel(xCoords[j],yCoords[j]);
	}
	Array.getStatistics(pixelValues, min, max);
	minA[0]=min*(1-colLowTol);
	if(max*(1+colUppTol)>255){
		maxA[0]=255;
	}
	else{
		maxA[0]=max*(1+colUppTol);
	}
	filterA[0]="pass"; //"pass" or "stop"
	selectWindow("Green");
	rename("1");
	for(j=0; j<numSamples; j++){
		pixelValues[j] = getPixel(xCoords[j],yCoords[j]);
	}
	Array.getStatistics(pixelValues, min, max);
	minA[1]=min*(1-colLowTol);
	if(max*(1+colUppTol)>255){
		maxA[1]=255;
	}
	else{
		maxA[1]=max*(1+colUppTol);
	}
	filterA[1]="pass";
	selectWindow("Blue");
	rename("2");
	for(j=0; j<numSamples; j++){
		pixelValues[j] = getPixel(xCoords[j],yCoords[j]);
	}
	Array.getStatistics(pixelValues, min, max);
	minA[2]=min*(1-colLowTol);
	if(max*(1+colUppTol)>255){
		maxA[2]=255;
	}
	else{
		maxA[2]=max*(1+colUppTol);
	}
	filterA[2]="pass";

	for (j=0;j<3;j++){
		selectWindow(""+j);
		setThreshold(minA[j], maxA[j]);
		run("Convert to Mask");
		if (filterA[j]=="stop")  run("Invert");
	}
	imageCalculator("AND create", "0","1");
	imageCalculator("AND create", "Result of 0","2");
	for (j=0;j<3;j++){
		selectWindow(""+j);
		close();
	}
	selectWindow("Result of 0");
	close();
	selectWindow("Result of Result of 0");
	rename(img);

	settings = "size="+smallestArea+"-"+biggestArea+" circularity=0.30-1.00 clear add";
//	see if can get size of ROIs drawn to change the size.. maybe draw box around smallest, then largest spot?
//	option to save colour settings?
	run("Analyze Particles...", settings);
//	run("Analyze Particles...", "size=11.78-432.02 circularity=0.30-1.00 clear add");
	waitForUser;
}
*/

exit();





/* Testing for within ROI code
print("Started");
numSamples = 100;
getSelectionBounds(x,y,width,height);
minX = x;
minY = y;
maxX = minX+width;
maxY = minY+height;
xCoords = newArray(numSamples);
yCoords = newArray(numSamples);
print("Ready to run loop")
index=0;
skip=0;
while(index<numSamples){
	tempx = ((maxX-minX)*random)+minX;
	tempy = ((maxY-minY)*random)+minY;
	test = Roi.contains(tempx,tempy);
	if(test==1){
		xCoords[index] = tempx;
		yCoords[index] = tempy;	
		index++;
		print("Iteration "+index+" completed.");
	}else if(test==0){
		skip++;
		continue;
	}
}
print("Loop completed. Number of points sampled: "+index+". Number of skips: "+skip+".");
Array.show(xCoords);
Array.show(yCoords);
exit();
*/






/* Old click on point to get colour code
Dialog.create("Options");
Dialog.addNumber("Number of concentric rings in your circles (solid circles = 1):", 1)
Dialog.show();
numRings = Dialog.getNumber();

rgbValues = newArray(numRings*3);
setTool("dropper");
for(i=1; i<=numRings; i++){
	waitForUser( "From the outermost ring and moving inwards, click on anywhere within ring "+i+" and click OK." );
	color = getValue("rgb.foreground");
	rgbValues[(i-1)*3]=(color>>16)&0xff; //red
	rgbValues[((i-1)*3)+1]=(color>>8)&0xff; //green
	rgbValues[((i-1)*3)+2]=color&0xff; //blue
}

//for(i=1; i<=numRings; i++){
//	print("Ring "+i+" RGB: "+rgbValues[(i-1)*3]+", "+rgbValues[((i-1)*3)+1]+", "+rgbValues[((i-1)*3)+2]);
//}
*/

/* Colour threshold sample code
//run( "Set Measurements...", "area area_fraction redirect=None decimal=3" );
//setOption( "BlackBackground", true );
//run( "Lena (68K)" );
//img = getImageID();
//run( "Color Threshold..." );
//selectImage( img );
//run( "Make Binary" );
//run( "Measure" );
//selectWindow( "Results" );
*/
