/*
----------------------------------------------------------Title: ROI Renamer---------------------------------------------------------------
Version: 1.0
Updated: 21 Nov 2016

Description:
- This macro renames the ROIs in the ROI Manager in numerical sequence and can add a prefix/suffix if desired

-------------------------------------------------------------------------------------------------------------------------------------------
*/

nROIs = roiManager("count");
if(nROIs==0)
	exit("No ROIs were detected in your image.");
Dialog.create("Naming options");
Dialog.addMessage(nROIs+" ROIs detected.");
Dialog.setInsets(5,0,0);
Dialog.addMessage("----------------------")
Dialog.setInsets(5,0,0);
Dialog.addNumber("Start numbering from:", 1);
Dialog.setInsets(5,0,0);
Dialog.addMessage("Key in the prefix or/and suffix you would like to add to your ROIs. \nIf none are desired, leave the fields blank.");
Dialog.setInsets(5,0,0);
Dialog.addString("Prefix (if any):", "");
Dialog.setInsets(5,0,0);
Dialog.addString("Suffix (if any):", "");
Dialog.show();
start = Dialog.getNumber();
pre = Dialog.getString();
suf = Dialog.getString();

for(i=0; i<nROIs; i++){
	roiManager("select", i);
	name = pre+(start)+suf;
	roiManager("Rename", name);	
	start++;
}

exit("Ta-dah!");
