print("\\Clear");
print("Random sampler macro initiated ...\nCollecting options ...");
Dialog.create("Sampling options");
Dialog.addNumber("Number of samples needed:",10);
//Dialog.addNumber("How big do you want your ROIs?:",10);
if(nSlices>1){
	Dialog.setInsets(5,0,0);
	Dialog.addMessage("----------------------")
	Dialog.setInsets(5,0,0);
	Dialog.addMessage("Multiple slices have been detected in your image. \nPlease check all the slices that you want to analyse:")
	sliceNames = newArray(nSlices);
	for(i=1;i<=nSlices;i++){
		setSlice(i);
		sliceNames[i-1]=getInfo("slice.label");
		Dialog.addCheckbox(sliceNames[i-1], true);
	}
}
Dialog.show();

numROIs = Dialog.getNumber();
//size = Dialog.getNumber();
if(nSlices>1){
	sliceChoices = newArray(nSlices);
	for(i=0;i<nSlices;i++){
		sliceChoices[i] = Dialog.getCheckbox();
	}
}

setTool("rectangle");
run("Select None");
waitForUser("Draw a box around where you want your samples to be from:");
getSelectionBounds(x,y,width,height);

minX = x;
minY = y;
maxX = minX+width;
maxY = minY+height;

// Determine which slices need to be analysed
if(nSlices==1){
	numSlices = 1;
	slicesToAnalyse = newArray(1);
	slicesToAnalyse[0] = 1;
	sliceNames = newArray(1);
	sliceNames[0] = getTitle();
}else{
	numSlices = 0;
	for(i=0; i<lengthOf(sliceChoices); i++){
		if(sliceChoices[i] == true)
			numSlices++;
	}
	if(numSlices==0)
		exit("Error: No slices selected.");

	// Determine which slices to analyse
	slicesToAnalyse = newArray(numSlices);
	temp = 0;
	for(i=1; i<=lengthOf(sliceChoices); i++){
		if(sliceChoices[i-1] == true){
			slicesToAnalyse[temp] = i;
			temp++;
		}
	}
}
/*
xCoord = newArray(numROI);
yCoord = newArray(numROI);

for(i=0; i<numROI; i++)
	xCoord[i] = ((maxX-minX)*random)+minX;
for(i=0; i<numROI; i++)
	yCoord[i] = ((maxY-minY)*random)+minY;
*/

run("Clear Results");
for(i=0; i<numSlices; i++){
	setSlice(slicesToAnalyse[i]);
	mean = 0;
	for(j=0; j<numROIs; j++){
		xCoord = ((maxX-minX)*random)+minX;
		yCoord = ((maxY-minY)*random)+minY;
		setResult("X", j, xCoord);
		setResult("Y", j, yCoord);
		setResult(sliceNames[slicesToAnalyse[i]-1], j, getPixel(xCoord, yCoord));		
		setResult("Label", j, "s"+(j+1));
		mean = mean + (getPixel(xCoord, yCoord)/numROIs);
	}
	setResult(sliceNames[slicesToAnalyse[i]-1], numROIs, mean);
	setResult("Label", numROIs, "Mean");
}


print("Pixel values printed to Results table. \n-----End of Macro-----");
exit();


