/*
-------------------------------------------------------Title: Slice Averaging Macro-------------------------------------------------------
Version: 1.0
Updated: 1 Dec 2016

Description:
- This macro will create a single-slice image that is the average of all the slices in  the original image.

Requirements:
- Nil
----------------------------------------------------------------------------------------------------------------------------------------------------
*/
rois = File.openDialog("Choose the ROI zip file to open on the final image...");
setBatchMode(true);
oriName = getTitle();
selectWindow(oriName);
setSlice(1);
run("Duplicate...", "title=vR");
selectWindow(oriName);
setSlice(2);
run("Duplicate...", "title=vG");
selectWindow(oriName);
setSlice(3);
run("Duplicate...", "title=vB");
selectWindow(oriName);
//setSlice(4);
//run("Duplicate...", "title=uvB");
//selectWindow(oriName);
//setSlice(5);
//run("Duplicate...", "title=uvR");
imageCalculator("create average", "vR", "vG");
vRG = getTitle();
selectWindow("vR");
close();
selectWindow("vG");
close();
imageCalculator("create average", "vB", vRG);
//vRGB = getTitle();
//selectWindow(vRG);
//close();
//selectWindow("vB");
//close();
//imageCalculator("create average", "uvB", "uvR");
//uvBR = getTitle();
//selectWindow("uvR");
//close();
//selectWindow("uvB");
//close();
//imageCalculator("create average", vRGB, uvBR);
rename(oriName+"_averaged");
//selectWindow(vRGB);
//close();
//selectWindow(uvBR);
//close();
selectWindow(oriName+"_averaged");
setBatchMode(false);
roiManager("Open", rois);
exit();

print("\\Clear");
print("-----Slice Averaging Macro Initiated-----\nChecking your image ...");

//Check that there are at least 2 slices in the image
if(nSlices<2)
	exit("Error: There is only one slice in your image.");

print("Requirements met, beginning averaging ...\n... (this might take awhile) ...");

oriName = getTitle();
width = getWidth();
height = getHeight();
run("8-bit");

// note: could also use imageCalculator

/* OLD CODE: causes "java.lang.OutOfMemoryError: GC overhead limit exceeded" error
averaged = newArray(width*height);

for(i=1; i<=nSlices; i++){
	setSlice(i);
	for(j=0; j<height; j++){
		for(k=0; k<width; k++){
			averaged[(j*width)+k] = averaged[(j*width)+k] + (getPixel(k, j)/nSlices);
		}
	}
}
*/

/* OLD CODE 2: literally takes ages
newImage(oriName+"_averaged", "8-bit black", width, height, 1);
setBatchMode("true");
selectWindow(oriName);
for(i=1; i<=nSlices; i++){

print("Slice "+i+" started");

	setSlice(i);
	for(j=0; j<height; j++){

print("Row "+j+" started");

		for(k=0; k<width; k++){

if(k%100==0)
	print("Pixel "+k+" started");
			selectWindow(oriName);
			temp = (getPixel(k, j)/nSlices);
			selectWindow(oriName+"_averaged");
			temp2 = getPixel(k, j);
			setPixel(k, j, temp + temp2);
		}
	}
}
*/

//print(averaged[0], averaged[lengthOf(averaged)/2], averaged[lengthOf(averaged)-1]);
//Array.print(averaged);
setBatchMode("false");
exit();


setPixel(x, y, value)
