################################## PAT-GEOM v1.0.0 ######################################
#				Updated: 2 Dec 2018				    	#
# Macros and Tools written by Ian ZW Chan, GUI written by Aaron Teo and Ian ZW Chan 	#
#########################################################################################

from javax.swing import BorderFactory, SwingWorker, JButton, JFrame, JTextField, JLabel, SwingConstants, JPanel, JTextArea, ImageIcon
from java.awt import Dimension, Font, BorderLayout, Component, GridLayout, Color, GridBagLayout, GridBagConstraints, Insets, Image
from ij import IJ
from javax.swing.border import EtchedBorder
from ij.gui import GenericDialog 

selectedanalysis = ''

class soupTask( SwingWorker ) :
    def doInBackground( self ) :
        #-----------------------------------------------------------------------
        # Disable the text (input) field, if it exists
        #-----------------------------------------------------------------------
        try :
            IJ.run(selectedanalysis)
        except :
            Type, value = sys.exc_info()[ :2 ]
            print 'Error:', str( type )
            print 'value:', str( value )
            self.msg.setText( str( value ) )

###################################################
##### Defining what clicking each button does #####
###################################################
def phaction(event):
    global selectedanalysis 
    selectedanalysis = ' Contrast CoVAnalysis'
    soupTask().execute()

def phaction2(event):
    global selectedanalysis
    selectedanalysis = ' DirectionalityOfDistribution'
    soupTask().execute()

def phaction3(event):
    global selectedanalysis
    selectedanalysis = ' DirectionalityOfShape'
    soupTask().execute()

def phaction4(event):
    global selectedanalysis
    selectedanalysis = ' MarkingMatrix'
    soupTask().execute()

def phaction5(event):
    global selectedanalysis
    selectedanalysis = ' Randomness GifAnalysis'
    soupTask().execute()

def phaction6(event):
    global selectedanalysis
    selectedanalysis = ' Shape EllipticalFourierAnalysis'
    soupTask().execute()

def phaction7(event):
    global selectedanalysis
    selectedanalysis = ' Size CentroidSize'
    soupTask().execute()

def phaction8(event):
    global selectedanalysis
    selectedanalysis = ' RandomPixelSampler'
    soupTask().execute()

def phaction9(event):
    global selectedanalysis
    selectedanalysis = ' ROIrandomiser'
    soupTask().execute()

def phaction10(event):
    global selectedanalysis
    selectedanalysis = ' ROIrenamer'
    soupTask().execute()
##################################################

##################################################
############ Creating the GUI window #############
##################################################

frame = JFrame("Ian ZW Chan proudly presents PAT-GEOM v1.0")
frame.setResizable(False)

##################################################
############## "Image Analysis" Panel ############
##################################################

panel1 = JPanel(GridBagLayout())
panel1.setBorder(
    BorderFactory.createTitledBorder(
    BorderFactory.createEtchedBorder(
        EtchedBorder.RAISED, Color.GRAY, Color.DARK_GRAY), "Image Analysis"))
panel1.getBorder().setTitleFont(Font("Dialog", Font.BOLD, 15))
##################################################

##################################################
##### Creating the individual button objects #####
##################################################

conrmsbutton = JButton('Contrast CoV', actionPerformed=phaction)
conrmsbutton.setFont(Font("Dialog", Font.BOLD, 15))
conrmsbutton.setHorizontalTextPosition(JButton.CENTER)
conrmsbutton.setVerticalTextPosition(JButton.CENTER)
dirdistbutton = JButton('Directionality of Distribution', actionPerformed=phaction2)
dirdistbutton.setFont(Font("Dialog", Font.BOLD, 15))
dirshapbutton = JButton('Directionality of Shape', actionPerformed=phaction3)
dirshapbutton.setFont(Font("Dialog", Font.BOLD, 15))
markmatbutton = JButton('Marking Matrix', actionPerformed=phaction4)
markmatbutton.setFont(Font("Dialog", Font.BOLD, 15))
randgifbutton = JButton('Randomness Gif', actionPerformed=phaction5)
randgifbutton.setFont(Font("Dialog", Font.BOLD, 15))
foushapbutton = JButton('Elliptical Fourier Shape Analysis', actionPerformed=phaction6)
foushapbutton.setFont(Font("Dialog", Font.BOLD, 15))
censizebutton = JButton('Centroid Size', actionPerformed=phaction7)
censizebutton.setFont(Font("Dialog", Font.BOLD, 15))
##################################################

##################################################
####### Placing the buttons into the panel #######
##################################################

c = GridBagConstraints()
c.gridx = 3   
c.gridy = 0
c.gridwidth = 3
c.weightx = 0.5
c.insets = Insets(10, 10, 10, 10)
c.fill = GridBagConstraints.HORIZONTAL
panel1.add(dirdistbutton, c)

c = GridBagConstraints()
c.gridx = 0   
c.gridy = 0
c.gridwidth = 3
c.weightx = 0.5
c.insets = Insets(10, 10, 10, 10)
c.fill = GridBagConstraints.HORIZONTAL
panel1.add(markmatbutton, c)

c = GridBagConstraints()
c.gridx = 0
c.gridy = 1
c.gridwidth = 3
c.weightx = 0.5
c.insets = Insets(10, 10, 10, 10)
c.fill = GridBagConstraints.HORIZONTAL
panel1.add(randgifbutton, c)

c = GridBagConstraints()
c.gridx = 3   
c.gridy = 1
c.gridwidth = 3
c.weightx = 0.5
c.insets = Insets(10, 10, 10, 10)
c.fill = GridBagConstraints.HORIZONTAL
panel1.add(foushapbutton, c)

c = GridBagConstraints()
c.gridx = 4    
c.gridy = 2
c.gridwidth = 2
c.weightx = 0.5
c.insets = Insets(10, 10, 10, 10)
c.fill = GridBagConstraints.HORIZONTAL
panel1.add(conrmsbutton, c)

c = GridBagConstraints()
c.gridx = 2   
c.gridy = 2
c.gridwidth = 2
c.weightx = 0.5
c.insets = Insets(10, 10, 10, 10)
c.fill = GridBagConstraints.HORIZONTAL
panel1.add(dirshapbutton, c)

c = GridBagConstraints()
c.gridx = 0
c.gridy = 2
c.gridwidth = 2
c.weightx = 0.5
c.insets = Insets(10, 10, 10, 10)
c.fill = GridBagConstraints.HORIZONTAL
panel1.add(censizebutton, c)
##################################################

##################################################
################## "Tools" Panel #################
##################################################

panel2 = JPanel(GridBagLayout())
panel2.setBorder(
    BorderFactory.createTitledBorder(
    BorderFactory.createEtchedBorder(
        EtchedBorder.RAISED, Color.GRAY, Color.DARK_GRAY), "Tools"))
panel2.getBorder().setTitleFont(Font("Dialog", Font.BOLD, 15))
##################################################

##################################################
### Creating button objects for the Tools panel ##
##################################################

randpixbutton = JButton('Random Pixel Sampler', actionPerformed=phaction8)
randpixbutton.setFont(Font("Dialog", Font.BOLD, 15))
roirandbutton = JButton('ROI Randomiser', actionPerformed=phaction9)
roirandbutton.setFont(Font("Dialog", Font.BOLD, 15))
roirenabutton = JButton('ROI Renamer', actionPerformed=phaction10)
roirenabutton.setFont(Font("Dialog", Font.BOLD, 15))

#####Placing the buttons onto the panel#####
c = GridBagConstraints()
c.gridx = 0    
c.gridy = 0
c.gridwidth = 1
c.weightx = 0.2
c.insets = Insets(10, 10, 10, 10)
c.fill = GridBagConstraints.HORIZONTAL
panel2.add(randpixbutton, c)

c = GridBagConstraints()
c.gridx = 1    
c.gridy = 0
c.gridwidth = 1
c.weightx = 0.5
c.insets = Insets(10, 10, 10, 10)
c.fill = GridBagConstraints.HORIZONTAL
panel2.add(roirandbutton, c)

c = GridBagConstraints()
c.gridx = 2    
c.gridy = 0
c.gridwidth = 1
c.weightx = 0.5
c.insets = Insets(10, 10, 10, 10)
c.fill = GridBagConstraints.HORIZONTAL
panel2.add(roirenabutton, c)
##################################################

##################################################
########## "Suggest an Analysis" Panel ###########
##################################################

panel3 = JPanel(GridBagLayout())
panel3.setBorder(
    BorderFactory.createTitledBorder(
    BorderFactory.createEtchedBorder(
        EtchedBorder.RAISED, Color.GRAY, Color.DARK_GRAY), "Suggest An Analysis"))
panel3.getBorder().setTitleFont(Font("Dialog", Font.BOLD, 15))
##################################################

##################################################
######## Creating the dialogue and outputs #######
##################################################
slabel = JLabel('Suggested Analysis', SwingConstants.CENTER)
slabel.setBorder(BorderFactory.createLoweredBevelBorder())
slabel.setFont(Font("Dialog", Font.BOLD, 15))

def getOptions(event):  
  gd = GenericDialog("Analysis Wizard")
  radiobuttonlabels = ["overall shapes of the markings", "length-width ratio and angle of the markings", "size of the markings", "contrast of the markings", "angle and linearity of the pattern formed by individual markings", "the distribution of the markings", "the randomness of the markings"]  
  gd.addRadioButtonGroup("Welcome to the Analysis Wizard. Please select a choice below. Are you most interested in quantifying/comparing the:", radiobuttonlabels, 7, 1, "overall shapes of the markings") 
  gd.showDialog()  
  # Read out the options  
  name = gd.getNextRadioButton() 
  if name == radiobuttonlabels[0]:
    name = "Elliptical Fourier Shape Analysis" 
  elif name == radiobuttonlabels[1]:
    name = "Directionality of Shape"
  elif name == radiobuttonlabels[2]:
    name = "Centroid Size"
  elif name == radiobuttonlabels[3]:
    name = "Contrast CoV"
  elif name == radiobuttonlabels[4]:
    name = "Directionality of Distribution"
  elif name == radiobuttonlabels[5]:
    name = "Marking Matrix"
  elif name == radiobuttonlabels[6]:
    name = "Randomness Gif"
        
  if gd.wasCanceled():
    name = "No Analysis Selected"
  slabel.setText(name) 
##################################################

##################################################
############### Creating the button ##############
##################################################
sbutton = JButton('Image Type', actionPerformed=getOptions)
sbutton.setFont(Font("Dialog", Font.BOLD, 15))

c = GridBagConstraints()
c.gridx = 0    
c.gridy = 0
c.gridwidth = 1
c.insets = Insets(10, 10, 10, 10)
c.fill = GridBagConstraints.HORIZONTAL
c.weightx = 0.25
panel3.add(sbutton, c)

c = GridBagConstraints()
c.gridx = 1    
c.gridy = 0
c.gridwidth = 3
c.insets = Insets(10, 10, 10, 10)
c.fill = GridBagConstraints.HORIZONTAL
c.weightx = 0.75
panel3.add(slabel, c)
##################################################

##################################################
####### Adding the panels to the GUI window ######
##################################################

frame.add(panel3, BorderLayout.PAGE_END)
frame.add(panel2, BorderLayout.CENTER)
frame.add(panel1, BorderLayout.PAGE_START)

frame.pack()
frame.setVisible(True)
##################################################
